variables:
  ## This value MUST be the same as `opam_repository_tag` in `scripts/version.sh`
  build_deps_image_version: 4aabc02a9c160ecae2a39153c27c0a67000a999b
  build_deps_image_name: registry.gitlab.com/tezos/opam-repository
  GIT_STRATEGY: fetch
  GIT_DEPTH: "1"
  GET_SOURCES_ATTEMPTS: "2"
  ARTIFACT_DOWNLOAD_ATTEMPTS: "2"
  # Sets the number of tries before failing opam downloads.
  OPAMRETRIES: "5"

  TEZOS_DEFAULT_BRANCH: "master"
  TEZOS_DEFAULT_NAMESPACE: "tezos"

# Basic, specialised, minimal, orthogonal templates

# Some settings we want by default on all jobs
.default_settings_template:
  interruptible: true
  # `dependencies` are empty be default. Each individual job or
  # template requiring artifacts from preceeding jobs should declare
  # their dependencies locally.
  dependencies: []

# Image templates
.image_template__runtime_build_test_dependencies_template:
  image: ${build_deps_image_name}:runtime-build-test-dependencies--${build_deps_image_version}

.image_template__runtime_build_dependencies_template:
  image: ${build_deps_image_name}:runtime-build-dependencies--${build_deps_image_version}

.image_template__runtime_prebuild_dependencies_template:
  image: ${build_deps_image_name}:runtime-prebuild-dependencies--${build_deps_image_version}

# Match GitLab executors version and directly use the Docker socket
# The Docker daemon is already configured, experimental features are enabled
# The following environment variables are already set:
# - BUILDKIT_PROGRESS
# - DOCKER_DRIVER
# - DOCKER_VERSION
# https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-socket-binding
.image_template__docker:
  image: docker:20.10.12

.image_template__alpine:
  image: alpine:3.15

# Rules template

# Rules for all the jobs that need to be run on development branches (typically
# those that have an MR, but also some experiments, etc.)
.rules_template__development:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    # No jobs on test latest release
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - when: on_success

# Same as .rules_template__development, but for manual jobs.
.rules_template__development_manual:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    # No jobs on test latest release
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - when: manual

# Rules for all the jobs that are run only for the master branch and the like
# (tags, releases, etc.)
.rules_template__master_and_releases:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE"'
      when: never
    # Valid release tag: vX.Y or vX.Y-rcZ
    - if: '$CI_COMMIT_TAG =~ /^v\d+\.\d+(?:\-rc\d+)?$/ && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
      variables:
        CI_DOCKER_HUB: "true"
    # No jobs on latest release branches
    - if: '($CI_COMMIT_REF_NAME == "latest-release" || $CI_COMMIT_REF_NAME == "test-latest-release")'
      when: never
    # Match 'vX-release' branches only
    - if: '($CI_COMMIT_BRANCH =~ /v[0-9]{1,3}-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /v[0-9]{1,3}-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
      variables:
        CI_DOCKER_HUB: "true"
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
      variables:
        CI_DOCKER_HUB: "true"
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
      variables:
        CI_DOCKER_HUB: "true"
    # Testing
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: on_success
    - when: never

# Rules for all the jobs that are run only for the master branch
.rules_template__master:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
    - when: never

# Rules for all the jobs that are run only on release tags
.rules_template__release_tag:
  rules:
    # Valid release tag: vX.Y or vX.Y-rcZ
    - if: '$CI_COMMIT_TAG =~ /^v\d+\.\d+(?:\-rc\d+)?$/ && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
    # Testing
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: on_success
    - when: never

# Rules for all the jobs that are run only on latest release branches
.rules_template__latest_release:
  rules:
    # Production: push to Docker Hub
    - if: '$CI_COMMIT_REF_NAME == "latest-release" && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: on_success
      variables:
        CI_DOCKER_HUB: "true"
    # Testing: push to GitLab container registry
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: on_success
    - when: never

# Rules for jobs that should run all the time except on latest release branches
.rules_template__not_on_latest_release:
  rules:
    # No jobs on latest release branches
    - if: '($CI_COMMIT_REF_NAME == "latest-release" || $CI_COMMIT_REF_NAME == "test-latest-release")'
      when: never
    - when: on_success

# Rules for specific topics: doc, opam, etc.
.rules_template__development_documentation:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE" && $TZ_SCHEDULE_KIND == "EXTENDED_TESTS"'
      when: always
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    # No jobs on latest release branches
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME == $TEZOS_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_MERGE_REQUEST_ID'
      changes:
        - docs/introduction/*.sh
      when: on_success
    # Run when there is label on the merge request.
    - if: '$CI_MERGE_REQUEST_LABELS =~ /(?:^|[,])ci--docs(?:$|[,])/'
      when: on_success
    - when: manual
      allow_failure: true

# The job `unified_coverage` runs on master and one development pipelines. It
# runs on merge requests, unless the `ci--no-coverage` tag is set.
.rules_template__development_unified_coverage:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE"'
      when: never
    # No jobs on test latest release
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - if: '$CI_COMMIT_TAG && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    # Disable this job when the MR has the label `ci--no-coverage`
    - if: '$CI_MERGE_REQUEST_LABELS =~ /(?:^|[,])ci--no-coverage(?:$|[,])/'
      when: never
    - when: on_success

.rules_template__development_arm64:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE" && $TZ_SCHEDULE_KIND == "EXTENDED_TESTS"'
      when: always
    - if: '$CI_COMMIT_BRANCH =~ /arm64/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /arm64/'
      when: on_success
    # Run when there is label on the merge request.
    - if: '$CI_MERGE_REQUEST_LABELS =~ /(?:^|[,])ci--arm64(?:$|[,])/'
      when: on_success
    # No jobs on test latest release
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    - when: manual
      allow_failure: true

.rules_template__development_docker:
  rules:
    # No jobs on test latest release
    - if: '$CI_COMMIT_REF_NAME == "test-latest-release" && $CI_PROJECT_NAMESPACE == "nomadic-labs"'
      when: never
    # No development jobs on release branches
    - if: '($CI_COMMIT_BRANCH =~ /-release$/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /-release$/) && $CI_PROJECT_NAMESPACE == $TEZOS_DEFAULT_NAMESPACE'
      when: never
    # Run when docker is in the branch name
    - if: '$CI_COMMIT_BRANCH =~ /docker/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /docker/'
      when: on_success
    # Run when there is label on the merge request.
    - if: '$CI_MERGE_REQUEST_LABELS =~ /(?:^|[,])ci--docker(?:$|[,])/'
      when: on_success
    - if: $CI_COMMIT_BRANCH || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME
      when: manual
      allow_failure: true
    - when: never

.rules_template__development_dockerfile:
  rules:
    # Only run on merge requests when Dockerfiles have changed
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      changes:
        - build.Dockerfile
        - Dockerfile
    - when: never # default

.rules_template__extended_test_pipeline:
  rules:
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE" && $TZ_SCHEDULE_KIND == "EXTENDED_TESTS"'
      when: always
    - when: never

# this template makes sure that the child pipelines ( triggered ) is always run
.rules_template__opam:
  rules:
    # Run on child pipelines
    - if: '$CI_PIPELINE_SOURCE == "parent_pipeline"'
      when: on_success
    - when: never # default

.rules_template__trigger_opam_pipeline:
  rules:
    # Run on scheduled builds.
    - if: '$TZ_PIPELINE_KIND == "SCHEDULE" && $TZ_SCHEDULE_KIND == "EXTENDED_TESTS"'
      when: always
    # Never run on branch pipelines for master.
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH'
      when: never
    # Run when the branch name contains the `opam` keyword.
    - if: '$CI_COMMIT_BRANCH =~ /opam/ || $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /opam/'
      when: on_success
    # Run when there is label on the merge request.
    - if: '$CI_MERGE_REQUEST_LABELS =~ /(?:^|[,])ci--opam(?:$|[,])/'
      when: on_success
    # Run on merge requests when opam changes are detected.
    - if: '$CI_MERGE_REQUEST_ID'
      changes:
        - "**/dune"
        - "**/dune.inc"
        - "**/*.dune.inc"
        - "**/dune-project"
        - "**/dune_protocol.*"
        - "**/*.opam"
        - scripts/version.sh
        - .gitlab-ci.yml
      when: on_success
    - when: never # default

.rules_template__merge_request_only:
  rules:
    # Only run on merge requests
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: on_success
    - when: never # default

.rules_template__tezos_default_branch_only:
  rules:
    - if: '$CI_COMMIT_BRANCH == $TEZOS_DEFAULT_BRANCH'
      when: on_success
    - when: never # default

# Job templates

# This template is used by the opam test jobs in the child pipeline
# triggered by `packaging.yml`.
# We extend the rules_template__opam to ensure that this pipeline is
# always run whenever is triggered
.opam_template:
  extends:
    - .default_settings_template
    - .image_template__runtime_prebuild_dependencies_template
    - .rules_template__opam
  stage: packaging
  # FIXME: https://gitlab.com/nomadic-labs/tezos/-/issues/663
  # FIXME: https://gitlab.com/nomadic-labs/tezos/-/issues/664
  # At the time of writing, the opam tests were quite flaky.
  # Therefore, a retry was added. This should be removed once the
  # underlying tests have been fixed.
  retry: 2
  script:
    - ./scripts/opam-pin.sh
    - opam depext --yes ${package}
    - opam install --yes ${package}
    - opam reinstall --yes --with-test ${package}
  # Start immediately, don't wait for previous stages to succeeds
  needs: []
  after_script:
    # Stores logs in opam_logs/ for artifacts and outputs an excerpt on failure.
    - OPAM_LOGS=opam_logs/ ./scripts/ci/opam_handle_output.sh
  artifacts:
    paths:
      - opam_logs/
    expire_in: 1 week
    when: always

# Add variables for bisect_ppx instrumentation
.template__coverage:
  variables:
    COVERAGE_OPTIONS: --instrument-with bisect_ppx
    BISECT_FILE: $CI_PROJECT_DIR/_coverage_output/
    SLACK_COVERAGE_CHANNEL: C02PHBE7W73

# Merge coverage files after the execution
.template__coverage_files:
  extends: .template__coverage
  artifacts:
    name: "coverage-files-$CI_JOB_ID"
    paths:
      - $BISECT_FILE
    expire_in: 1 day
    when: on_success

.build_template:
  extends:
    - .default_settings_template
    - .image_template__runtime_build_test_dependencies_template
    - .template__coverage
    - .rules_template__not_on_latest_release
  stage: build
  before_script:
    - . ./scripts/version.sh
    # Load the environment poetry previously created in the docker image.
    # Give access to the Python dependencies/executables
    - . $HOME/.venv/bin/activate

.docker_registry_auth:
  before_script:
    - ./scripts/ci/docker_registry_auth.sh

.template__code_quality:
  variables:
    CODE_QUALITY_REPORT: "_reports/gl-code-quality-report.json"
